server/vessel/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('home');
Route::get('/home', 'HomeController@index')->name('home');

/** Authentication Routes **/
Auth::routes();

/** User Routes **/
Route::get('/user/profile/{id}', 'UserProfileController@show')->name('user.profile')->middleware('auth');
Route::post('/user/profile/{id}/update', 'UserProfileController@update')->name('user.profile.update')->middleware('auth');
Route::resource('user', 'UserController')->middleware('auth');

/** File Routes **/
Route::resource('file', 'FileController')->middleware('auth', 'authorizeRole:admin');

/** File Ignore Type Routes **/
Route::resource('file_ignore_type', 'FileIgnoreTypeController')->middleware('auth', 'authorizeRole:admin');
Route::post('/file_ignore_type/delete', 'FileIgnoreTypeController@destroyMultiple')->name('file_ignore_type.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** File Ignore Dir Routes **/
Route::resource('file_ignore_dir', 'FileIgnoreDirController')->middleware('auth', 'authorizeRole:admin');
Route::post('/file_ignore_dir/delete', 'FileIgnoreDirController@destroyMultiple')->name('file_ignore_dir.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Storage Provider Routes **/
Route::resource('storage', 'StorageController')->middleware('auth', 'authorizeRole:admin');
Route::post('/storage/delete', 'StorageController@destroyMultiple')->name('storage.provider.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** AppClient Routes **/
Route::resource('client', 'AppClientController')->middleware('auth', 'authorizeRole:admin');
Route::post('/client/delete', 'AppClientController@destroyMultiple')->name('client.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Setting Routes **/
Route::resource('setting', 'SettingController')->middleware('auth', 'authorizeRole:admin');
Route::post('/setting/all', 'SettingController@updateAll')->name('setting.updateAll')->middleware('auth', 'authorizeRole:admin');

/** User Setting Routes **/
Route::resource('user_setting', 'UserSettingController')->middleware('auth', 'authorizeRole:admin');
Route::post('/user_setting/delete', 'UserSettingController@destroyMultiple')->name('user_setting.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** User Role Routes **/
Route::resource('user_role', 'UserRoleController')->middleware('auth', 'authorizeRole:admin');
Route::post('/user_role/delete', 'UserRoleController@destroyMultiple')->name('user_role.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Deployment Routes **/
Route::resource('deployment', 'DeploymentController')->middleware('auth', 'authorizeRole:admin');
Route::post('/deployment/delete', 'DeploymentController@destroyMultiple')->name('deployment.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Search Routes **/
Route::get('/search/{str}', 'SearchController@search');
Route::post('/search/logs', 'SearchController@searchLog');

/** Monitoring Routes **/
Route::resource('log', 'AppLogController')->middleware('auth', 'authorizeRole:admin');

/** Download Routes **/
Route::get('/download/{id}', 'DownloadController@downloadFile')->middleware('auth');

/** LDAP Routes **/
Route::resource('ldap', 'LdapController')->middleware('auth', 'authorizeRole:admin');
Route::get('/ldap/{id}/import', 'LdapController@import')->name('ldap.import')->middleware('auth', 'authorizeRole:admin');

server/vessel/app/Role.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Role extends Model
{

		public function users()
		{
		  return $this->belongsToMany('App\User');
		}

    protected $table = 'role';

}

server/vessel/app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Laravel\Passport\HasApiTokens;
use Spatie\BinaryUuid\HasBinaryUuid;
use Illuminate\Support\Facades\DB;
use Laravel\Scout\Searchable;
use Adldap\Laravel\Traits\HasLdapUser;

class User extends Authenticatable
{
    use Notifiable;
    use HasBinaryUuid;
    use HasApiTokens;
		use Searchable;
		use HasLdapUser;

    public function getKeyName()
    {
        return 'user_id';
    }

		public static function getLastInsertId()
		{
			return DB::getPdo()->lastInsertId();
		}

    public function roles()
    {
      return $this->belongsToMany('App\Role', 'role_user', 'user_id', 'role_id');
    }

		public function files()
		{
			return $this->hasMany('App\File', 'user_id', 'user_id');
		}

		public function clients()
		{
			return $this->belongsToMany('App\AppClient', 'app_client_user', 'user_id', 'client_id');
		}

		public function settings()
		{
			return $this->hasMany('App\UserSetting', 'user_id', 'user_id');
		}

		public function logs()
		{
			return $this->hasMany('App\AppLogEntry', 'user_id', 'user_id');
		}

		//Credit for role authorization funcs: https://medium.com/@ezp127/laravel-5-4-native-user-authentication-role-authorization-3dbae4049c8a

		/**
		* @param string|array $roles
		*/
		public function authorizeRoles($roles)
		{
			if (is_array($roles)) {
				return $this->hasAnyRole($roles) || abort(401, 'This action is unauthorized.');
			}
			return $this->hasRole($roles) || abort(401, 'This action is unauthorized.');
		}

		/**
		* Check multiple roles
		* @param array $roles
		*/
		public function hasAnyRole($roles)
		{
			return null !== $this->roles()->whereIn('name', $roles)->first();
		}

		/**
		* Check one role
		* @param string $role
		*/
		public function hasRole($role)
		{
			return null !== $this->roles()->where('name', $role)->first();
		}

		public function storageProviders()
		{
			return $this->hasMany('App\StorageProviderUser', 'user_id', 'user_id');
		}

    public function getFullName()
    {
      return ($this->first_name . " " . $this->last_name);
    }

		public function getKey()
    {
        return $this->user_id_text;
    }

		public function toSearchableArray() {
			return [
				'user_id' => $this->user_id_text,
				'email' => $this->email,
				'user_name' => $this->user_name,
				'first_name' => $this->first_name,
				'last_name' => $this->last_name,
				'title' => $this->title,
				'office' => $this->office
			];
		}

		protected $primaryKey = 'user_id';
		public $incrementing = false;
		protected $table = 'users';
		protected $uuids = ['user_id'];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'user_id', 'first_name', 'last_name', 'email', 'password'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token'
    ];

		protected $dates = [
        'created_at',
        'updated_at',
        'last_login',
				'last_backup',
				'last_check_in'
    ];

		public $asYouType = true;

}

server/vessel/app/Http/Controllers/UserController.php
<?php

namespace App;
namespace App\Http\Controllers;

use App;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use Spatie\BinaryUuid\HasBinaryUuid;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;

class UserController extends Controller
{

		public function __construct()
		{
				$this->middleware('auth');
				$this->middleware('authorizeRole:admin');
		}

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

				$users = App\User::paginate(25);  //DB::table('users')->paginate(1);

				return view('user.list', ['users' => $users]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('user.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $user = new App\User();
				$user->email = $request->input('email');
				$user->user_name = $request->input('user_name');
				$user->first_name = $request->input('first_name');
				$user->last_name = $request->input('last_name');
				$user->password = Hash::make( $request->input('password') );
				$user->title = $request->input('title');
				$user->office = $request->input('office');
				$user->phone = $request->input('phone');
				$user->mobile = $request->input('mobile');
				$user->address = $request->input('address');
				$user->city = $request->input('city');
				$user->state = $request->input('state');
				$user->zip = $request->input('zip');
				$user->save();

				//Manually set to incrementing id - binary uuid side effect :()
				//$user->id = $user->getLastInsertId();

				//Assign the default user role
				$user->roles()->attach( App\Role::where('name', 'user')->first() );

				//Generate an API token
				$token = $user->createToken('Vessel API');
				$user->api_token = $token->accessToken;
				$user->save();

				return $this->index()->with(['success' => 'User ' . $user->email . ' was created successfully']);

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
				$user = App\User::withUuid($id)->first();
				$userSettings = $user->settings;
				$totalFiles = App\File::where('user_id', $user->user_id)->count();

				$stats = (object)[
					'totalFiles' => $totalFiles
				];

        return view('user.show', ['user' => $user, 'userSettings' => $userSettings, 'stats' => $stats]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

server/vessel/resources/views/user/roles/create.blade.php
@extends('layouts.app')

@section('scripts')
	<script>
		$(document).ready( function() {

			$('.ui.form')
			  .form({
			    fields: {
			      setting: {
			        identifier: 'role',
			        rules: [
			          {
			            type   : 'empty',
			            prompt : 'Please select a role'
			          }
			        ]
			      },
			      user: {
			        identifier: 'user',
			        rules: [
			          {
			            type   : 'empty',
			            prompt : 'Please specify a user'
			          }
			        ]
			      }
			    }
			  });

			$('.message .close')
				.on('click', function() {
					$(this)
						.closest('.message')
						.transition('fade')
					;
				});

		});
	</script>
@endsection

@section('content')

<div class="ui very padded container">

	<h2 class="ui header">
		Add User Role
		<div class="sub header"></div>
	</h2>

	@if( isset($error) )
		<div class="ui negative message">
			<i class="close icon"></i>
			<div class="header">
				{{ $error }}
			</div>
		</div>
	@endif

	<form method="POST" action="{{ route('user_role.store') }}" class="ui form segment">
		@csrf

		<div class="ui centered stackable grid container">

		  <div class="eight wide column field">
		    <label>Role</label>
				<select name="role" id="role" class="ui dropdown" required>
					<option class="item" value="">-- Select a Role --</option>
					@foreach($roles as $role)
						<option class="item" value="{{ $role->id }}">{{ $role->name }}</option>
					@endforeach
				</select>
		  </div>

		  <div class="eight wide column field">
		    <label>User</label>
		    <select id="user" name="user" class="ui search dropdown" required>
					<option class="item" value="">-- Select a User --</option>
					@foreach($users as $user)
						<option value="{{ $user->uuid_text }}">{{ $user->first_name }} {{$user->last_name }}</option>
					@endforeach
				</select>
		  </div>

			<div class="row">
				<div class="eight wide centered column">
					<div class="ui error message"></div>
				</div>
			</div>
			<div class="row">
				<div class="three wide column">
				  <div class="ui primary submit button">{{ __('Add') }}</div>
				</div>
			</div>

		</div>
	</form>

</div>
@endsection

server/vessel/resources/views/user/roles/list.blade.php
@extends('layouts.app')

@section ('scripts')
	<script src="{{ asset('js/tablesort.min.js') }}"></script>
	<script>
		$(document).ready( function() {

			$('.message .close')
				.on('click', function() {
					$(this)
						.closest('.message')
						.transition('fade');
				});

			$('.menu .item').tab();

			var list_form = $('#list_form');

			$('table').tablesort();

			$('#delete_selected').click(function() {
				$('input[name="_method"]').val('POST');
				list_form.attr('action', '{{ route('user_role.destroyMultiple') }}');
				list_form.submit();
			});

			$('#add_role').click(function(e) {
				e.preventDefault();
				window.location.href= '{{ route('user_role.create') }}';
			});

		});
	</script>
@endsection

@section('content')

	<div class="ui very padded container">

		@if(isset($success))
		<div class="ui positive message">
			<i class="close icon"></i>
			<div class="header">
				{{ $success }}
			</div>
		</div>
		@endif

		@if(isset($error))
		<div class="ui negative message">
			<i class="close icon"></i>
			<div class="header">
				{{ $error }}
			</div>
		</div>
		@endif

		<h2 class="ui header">
			User Roles
			<div class="sub header">View and Manage User Roles</div>
		</h2>
	</div>

	<form id="list_form" action="" method="POST">
		@csrf
		<input type="hidden" name="_method" value="post" />

		<div class="ui very padded container">
			<table class="ui selectable sortable stackable padded striped table">
				<thead>
					<tr>
						<th class="no-sort" colspan="8">
			      	{{ $userRoles->links() }}
			    	</th>
				  </tr>
					<tr>
						<th class="no-sort"></th>
						<th>Role</th>
						<th>User</th>
					</tr>
				</thead>
				<tbody>
					@foreach ($userRoles as $role)
						<tr>
							<td>
								<div class="ui fitted checkbox">
				          <input name="selectedIds[]" type="checkbox" value="{{ $role->id }}"><label></label>
				        </div>
							</td>
							<td><a href="{{ route('user_role.show', $role->id) }}">{{ $role->role->name }}</td>
							<td>{{ $role->user->first_name }} {{ $role->user->last_name }}</td>
						</tr>
					@endforeach
				</tbody>
				<tfoot>
			    <tr>
						<th colspan="8">
							<div class="ui">
								<button id="add_role" class="ui primary button">
									<i class="icon plus"></i>
								  Add
								</button>
								<button id="delete_selected" class="red ui button">
									<i class="icon delete"></i>
								  Delete
								</button>
							</div>
				      {{ $userRoles->links() }}
			    	</th>
				  </tr>
				</tfoot>
			</table>
		</div>

	</form>

@endsection

server/vessel/resources/views/user/roles/show.blade.php
@extends('layouts.app')

@section('scripts')
	<script>
		$(document).ready( function() {

			$('.ui.form')
			  .form({
			    fields: {
			      setting: {
			        identifier: 'role',
			        rules: [
			          {
			            type   : 'empty',
			            prompt : 'Please select a role'
			          }
			        ]
			      },
			      user: {
			        identifier: 'user',
			        rules: [
			          {
			            type   : 'empty',
			            prompt : 'Please specify a user'
			          }
			        ]
			      }
			    }
			  });

			$('.message .close')
				.on('click', function() {
					$(this)
						.closest('.message')
						.transition('fade')
					;
				});

				$('#delete_record').click(function() {
					$('input[name="_method"]').val('DELETE');
					list_form.submit();
				});

				$('#role').dropdown('set selected', '{{ $userRole->role_id }}');
				$('#user').dropdown('set selected', '{{ App\User::decodeUuid($userRole->user_id) }}');
		});
	</script>
@endsection

@section('content')

<div class="ui very padded container">

	<h2 class="ui header">
		Manage User Role
		<div class="sub header"></div>
	</h2>

	@if( isset($error) )
		<div class="ui negative message">
			<i class="close icon"></i>
			<div class="header">
				{{ $error }}
			</div>
		</div>
	@endif

	<form method="POST" action="{{ route('user_role.update', $userRole->id) }}" class="ui form segment">
		@csrf
		<input type="hidden" name="_method" value="PUT" />

		<div class="ui centered stackable grid container">

		  <div class="eight wide column field">
		    <label>Role</label>
				<select name="role" id="role" class="ui dropdown" required>
					@foreach($roles as $role)
						<option class="item" value="{{ $role->id }}">{{ $role->name }}</option>
					@endforeach
				</select>
		  </div>

		  <div class="eight wide column field">
		    <label>User</label>
		    <select id="user" name="user" class="ui search dropdown" required>
					@foreach($users as $user)
						<option value="{{ $user->uuid_text }}">{{ $user->first_name }} {{$user->last_name }}</option>
					@endforeach
				</select>
		  </div>

			<div class="row">
				<div class="eight wide centered column">
					<div class="ui error message"></div>
				</div>
			</div>
			<div class="row">
				<div class="three wide column">
				  <div class="ui primary submit button">{{ __('Update') }}</div>
				</div>
				<div class="three wide column">
					<div id="delete_record" class="ui red submit button">
						<i class="icon delete"></i>
						Delete
					</div>
				</div>
			</div>

		</div>
	</form>

</div>
@endsection